# COOPGO multimodal routing service

COOPGO Multimodal routing service handles routing through different mobility modes :

- [X] Public transit
- [X] Carpool
- [X] Walking
- [X] Driving

## Notes on public transit

Public transit routing is built with [Valhalla](https://github.com/valhalla/valhalla) routing engine. In the future, we may implement our own.

Valhalla C++ library (libvalhalla.so) is embedded within Go using the CGO.

Bindings are available in [libs/transit/valhalla/bindings](libs/transit/valhalla/bindings). This is largely inspired by [https://github.com/pufferffish/valhalla-go](https://github.com/pufferffish/valhalla-go), except that we build with Docker and integrate it directly within the project.

